

// REQUIRES the following Arduino libraries:
// - DHT Sensor Library: https://github.com/adafruit/DHT-sensor-library
// - Adafruit Unified Sensor Lib: https://github.com/adafruit/Adafruit_Sensor

#define THINGER_SERIAL_DEBUG
#include <ThingerESP8266.h>
#define USERNAME "Najwa02"
#define DEVICE_ID "csw33703_060104"
#define DEVICE_CREDENTIAL "csw33703_060104"
#define SSID "UniSZA-WiFi"
#define SSID_PASSWORD "unisza2016"

ThingerESP8266 thing(USERNAME, DEVICE_ID, DEVICE_CREDENTIAL);

#include "DHT.h"//lib dht

#define DHTPIN 2     // Digital pin connected to the DHT sensor
#define DHTTYPE DHT11   // DHT 11

DHT dht(DHTPIN, DHTTYPE);//dht

//mq4 sensor
const int AO_Pin=0; // Connect AO of MQ4 with Analog channel 0 pin (A0) of Arduino
const int DO_Pin=16; // Connect DO of MQ4 with Digital pin 8 (D8) of Arduino
const int Led_Pin= D7; // Connect an LED with D6 pin of Arduino
int threshold_value; // A variable to store digital output of MQ4
int AO_Out; // stores analog output of MQ4 sensor


void setup() {
  Serial.begin(9600);
  Serial.println(F("DHT11 test!"));
  dht.begin();

    // add WiFi credentials
  thing.add_wifi(SSID, SSID_PASSWORD);

  //connection thinger to dht11
  
  thing["dht11"] >> [](pson& out){
    // Add the values and the corresponding code
    out["humidity"] = dht.readHumidity();
    out["celsius"] = dht.readTemperature();
   };

   //connection mq4 to thinger
   
    thing["Gas_Methane"] >> outputValue(analogRead(A0));
   
//mq4 sensor
Serial.begin(9600);  // Initialize serial communictation with a baud rate of 115200
pinMode(DO_Pin, INPUT); // Configure D8 pin as a digital input pin
pinMode(Led_Pin, OUTPUT); //Configure D6 pin as a digital output pin
digitalWrite(Led_Pin, HIGH);
}

void loop() {
    // Wait a few seconds between measurements.
  delay(2000);

  // Reading temperature or humidity takes about 250 milliseconds!
  // Sensor readings may also be up to 2 seconds 'old' (its a very slow sensor)
  float h = dht.readHumidity();
  // Read temperature as Celsius (the default)
  float t = dht.readTemperature();
  // Read temperature as Fahrenheit (isFahrenheit = true)
  float f = dht.readTemperature(true);

  // Check if any reads failed and exit early (to try again).
  if (isnan(h) || isnan(t) || isnan(f)) {
    Serial.println(F("Failed to read from DHT sensor!"));
    return;
  }

  // Compute heat index in Fahrenheit (the default)
  float hif = dht.computeHeatIndex(f, h);
  // Compute heat index in Celsius (isFahreheit = false)
  float hic = dht.computeHeatIndex(t, h, false);

  Serial.print(F(" Humidity: "));
  Serial.print(h);
  Serial.print(F("%  Temperature: "));
  Serial.print(t);
  Serial.print(F("C "));
  Serial.print(f);
  Serial.print(F("F  Heat index: "));
  Serial.print(hic);
  Serial.print(F("C "));
  Serial.print(hif);
  Serial.println(F("F"));

  //mq4
AO_Out= analogRead(AO_Pin); // Take Analog output measurement sample from AO pin of MQ4 sensor
threshold_value= digitalRead(DO_Pin); //Read digital output of MQ4 sensor
Serial.print("Methane Conentration: ");
Serial.println(AO_Out);//prints the methane value
Serial.print("threshold_value: ");
Serial.print(threshold_value);//prints the threshold_value reached as either LOW or HIGH (above or underneath)

delay(1000);

if (AO_Out >= 250){
digitalWrite(Led_Pin, HIGH);//if threshold_value has been reached, LED turns on as status indicator

}
else{
  
digitalWrite(Led_Pin, LOW);//if threshold not reached, LED remains off
}

  thing.handle();
}
